package org.ica.cosmo.application;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.util.List;

import org.lgmt.dgl.vecmath.Point3d;

public class GCodeWriter {
	private static String resourcesPath = new String("src/org/ica/cosmo/");
	
	private BufferedWriter writer;
	private int n = 1;

	public GCodeWriter(String filename) {
		try {
			writer = new BufferedWriter(new FileWriter(resourcesPath + "/" + filename + ".mpf"));
			writer.write(String.format("; %s.gcode --- generated by CoSMO\n", filename));
			this.appendLine(";");
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public void appendLine(String str) {
		try {
			writer.append(String.format("N%d %s\n", n, str));
			n++;
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public void appendLine(Point3d p) {
		try {
			writer.append(String.format("N%d X%.3f Y%.3f Z%.3f\n", n, p.x, p.y, p.z));
			n++;
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	public void appendLines(List<String> text) {
		for(String s: text)
			this.appendLine(s);
	}

	public void write() {
		try {
			writer.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public static void setResourcesPath(String resourcesPath) {
		GCodeWriter.resourcesPath = resourcesPath;
	}

}
